;;; quick-edit-mode.el --- Quickly edit stuff

;; Copyright (C) 2012  Tom Willemsen

;; Author: Tom Willemsen <slash@drd>
;; Keywords: convenience

;; This program is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.

;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.

;;; Commentary:

;; Quickly edit stuff

;;; Code:

(defvar quick-edit-map
  (let ((map (make-sparse-keymap)))
    (define-key map "n" 'next-line)
    (define-key map "p" 'previous-line)
    (define-key map "f" 'forward-char)
    (define-key map "b" 'backward-char)
    (define-key map "e" 'oni:move-end-of-dwim)
    (define-key map "a" 'oni:move-beginning-of-dwim)
    (define-key map "V" 'scroll-down-command)
    (define-key map "v" 'scroll-up-command)
    (define-key map "/" 'undo)
    (define-key map "w" 'oni:kill-region-or-backward-char)
    (define-key map "d" 'oni:kill-region-or-forward-char)
    (define-key map "k" 'oni:kill-region-or-line)
    (define-key map "K" 'kill-whole-line)
    (define-key map "j" 'newline-and-indent)
    (define-key map (kbd "RET") 'quick-edit-mode)
    map)
  "Keymap for quick-edit-mode.")

;;;###autoload
(define-minor-mode quick-edit-mode
  "Quickly edit stuff."
  :lighter " qe"
  :global t
  (if quick-edit-mode
      (setq overriding-local-map quick-edit-map)
    (setq overriding-local-map nil)))

(provide 'quick-edit-mode)
;;; quick-edit-mode.el ends here
